(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/modal'), require('@ng-tangram/components/switch'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/column-setting', ['exports', '@angular/common', '@angular/core', '@ng-tangram/components/modal', '@ng-tangram/components/switch', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.columnSetting = {}), global.ng.common, global.ng.core, global.modal, global._switch, global.rxjs, global.rxjs.operators));
}(this, (function (exports, common, core, modal, _switch, rxjs, operators) { 'use strict';

    var NtColumnSettingComponent = /** @class */ (function () {
        function NtColumnSettingComponent(data) {
            this.data = data;
            this._destroy = new rxjs.Subject();
            this._displayedColumnChanges = new rxjs.Subject();
            this.displayedColumns = [];
            this.columns = this.data.columns;
            this.columnNames = this.columns.map(function (col) { return col.name; });
            this.displayedColumns = this.data.displayedColumns;
        }
        NtColumnSettingComponent.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
        };
        NtColumnSettingComponent.prototype.displayedColumnChanges = function () {
            return this._displayedColumnChanges
                .asObservable()
                .pipe(operators.takeUntil(this._destroy));
        };
        NtColumnSettingComponent.prototype._onChange = function (change, columnName) {
            var _this = this;
            if (change.checked) {
                this.displayedColumns.push(columnName);
            }
            else {
                var index = this.displayedColumns.indexOf(columnName);
                this.displayedColumns.splice(index, 1);
            }
            var sortedColumns = this.columnNames.filter(function (name) { return _this.displayedColumns.includes(name); });
            this._displayedColumnChanges.next(sortedColumns);
        };
        NtColumnSettingComponent.prototype._trackColumnChecked = function (columnName) {
            return this.displayedColumns.includes(columnName);
        };
        return NtColumnSettingComponent;
    }());
    NtColumnSettingComponent.decorators = [
        { type: core.Component, args: [{
                    template: "<nt-modal-header>\u6570\u636E\u5217\u663E\u793A\u8BBE\u7F6E</nt-modal-header>\n<nt-modal-body class=\"padding-0\">\n  <div class=\"nt-column-setting\">\n    <div class=\"nt-column-setting-menu\">\n      <div class=\"nt-column-setting-item\"\n        [class.disabled]=\"!col.optional\"\n        *ngFor=\"let col of columns\">\n        <a class=\"nt-column-setting-label\">{{ col.label }}</a>\n        <span class=\"nt-column-setting-control\">\n          <nt-switch class=\"nt-column-switch large\"\n            [checked]=\"_trackColumnChecked(col.name)\"\n            (change)=\"_onChange($event, col.name)\"\n            [disabled]=\"!col.optional\"\n            circle>\n          </nt-switch>\n        </span>\n      </div>\n    </div>\n  </div>\n</nt-modal-body>\n",
                    encapsulation: core.ViewEncapsulation.None
                },] }
    ];
    NtColumnSettingComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [modal.NT_MODAL_DATA,] }] }
    ]; };

    var NtColumnSetting = /** @class */ (function () {
        function NtColumnSetting(modal) {
            this.modal = modal;
            this._defaultModalConfig = {
                width: '460px',
                maxWidth: '90vw',
                maxHeight: '90vh',
                backdropClass: 'light-backdrop'
            };
        }
        NtColumnSetting.prototype.openAndTrackChanges = function (columns, displayedColumns) {
            var data = { columns: columns, displayedColumns: displayedColumns };
            var modalConfig = Object.assign(Object.assign({}, this._defaultModalConfig), { data: data });
            var modalRef = this.modal.open(NtColumnSettingComponent, modalConfig);
            return modalRef.componentInstance.displayedColumnChanges();
        };
        return NtColumnSetting;
    }());
    NtColumnSetting.decorators = [
        { type: core.Injectable }
    ];
    NtColumnSetting.ctorParameters = function () { return [
        { type: modal.NtModal }
    ]; };

    var NtColumnSettingModule = /** @class */ (function () {
        function NtColumnSettingModule() {
        }
        return NtColumnSettingModule;
    }());
    NtColumnSettingModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        modal.NtModalModule,
                        _switch.NtSwitchModule
                    ],
                    entryComponents: [NtColumnSettingComponent],
                    declarations: [NtColumnSettingComponent],
                    providers: [NtColumnSetting],
                },] }
    ];

    exports.NtColumnSetting = NtColumnSetting;
    exports.NtColumnSettingComponent = NtColumnSettingComponent;
    exports.NtColumnSettingModule = NtColumnSettingModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=column-setting.umd.js.map
