(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/overlay'), require('@angular/common'), require('@angular/router'), require('@ng-tangram/components/overlay'), require('rxjs'), require('rxjs/operators'), require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/navigation', ['exports', '@angular/core', '@angular/cdk/overlay', '@angular/common', '@angular/router', '@ng-tangram/components/overlay', 'rxjs', 'rxjs/operators', '@angular/cdk/coercion'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.navigation = {}), global.ng.core, global.ng.cdk.overlay, global.ng.common, global.ng.router, global.nt.components.overlay, global.rxjs, global.rxjs.operators, global.ng.cdk.coercion));
}(this, (function (exports, core, overlay, common, router, overlay$1, rxjs, operators, coercion) { 'use strict';

    (function (NtNavUrlTreeStrategy) {
        NtNavUrlTreeStrategy[NtNavUrlTreeStrategy["Integrity"] = 0] = "Integrity";
        NtNavUrlTreeStrategy[NtNavUrlTreeStrategy["OnlyParents"] = 1] = "OnlyParents";
    })(exports.NtNavUrlTreeStrategy || (exports.NtNavUrlTreeStrategy = {}));
    var NT_NAV_CONFIG = new core.InjectionToken('nt-nav-config');

    var RESOLVE_TITLE_PLACEHOLDER = /^resolve::/;
    function resolveTitle(snapshot, title) {
        var _a;
        if (RESOLVE_TITLE_PLACEHOLDER.test(title)) {
            var paths = title.replace(RESOLVE_TITLE_PLACEHOLDER, '').split('.');
            var key = paths.shift();
            try {
                if (key && ((_a = snapshot.data) === null || _a === void 0 ? void 0 : _a.hasOwnProperty(key))) {
                    var data = snapshot.data[key];
                    var path = paths.shift();
                    var result = path ? data[path] : null;
                    while (paths.length > 0 && result instanceof Object) {
                        path = paths.shift();
                        result = path ? result[path] : null;
                    }
                    return result;
                }
                return key || '';
            }
            catch (e) {
                console.error(e);
            }
        }
        return title;
    }

    var NT_NAV_MENUS = new core.InjectionToken('nt-nav-menus');
    var NtNavigationAdapter = /** @class */ (function () {
        function NtNavigationAdapter(route, router$1, config, menus) {
            var _this = this;
            this.route = route;
            this.router = router$1;
            this.config = config;
            this.destroy = new rxjs.Subject();
            this.menus = new rxjs.BehaviorSubject([]);
            this.activatedUrlTree = new rxjs.BehaviorSubject([]);
            this.activeUrl = new rxjs.BehaviorSubject({});
            this.menus.next(this.fillNavMenuUrls(menus));
            router$1.events
                .pipe(operators.takeUntil(this.destroy), operators.filter(function (event) { return event instanceof router.NavigationEnd; }))
                .subscribe(function () { return _this.buildUrlTree(_this.route); });
        }
        NtNavigationAdapter.prototype.ngOnDestroy = function () {
            this.destroy.next();
            this.destroy.complete();
        };
        NtNavigationAdapter.prototype.getRouteMenus = function () {
            return this.menus.asObservable();
        };
        NtNavigationAdapter.prototype.fillNavMenuUrls = function (menus, parentPath) {
            var _this = this;
            menus.forEach(function (menu) {
                var commands = [_this.config.baseUrl || './'];
                if (!!parentPath) {
                    commands.push(parentPath);
                }
                if (menu.path) {
                    commands.push(menu.path);
                }
                menu.commands = commands;
                if (Array.isArray(menu.children) && menu.children.length > 0) {
                    _this.fillNavMenuUrls(menu.children, menu.path);
                }
            });
            return menus;
        };
        NtNavigationAdapter.prototype.buildUrlTree = function (route) {
            var url = [];
            var tree = [];
            while (route.firstChild) {
                route = route.firstChild;
                var snapshot = route.snapshot;
                if (snapshot.data && snapshot.data.title && snapshot.url.length > 0) {
                    var data = snapshot.data, title = void 0;
                    title = resolveTitle(snapshot, data.title);
                    url = url.concat(snapshot.url.map(function (segment) { return segment.path; }));
                    tree.push({ title: title, url: url, icon: data.icon });
                }
            }
            this.activeUrl.next(tree[tree.length - 1]);
            if (this.config.urlTreeStrategy === exports.NtNavUrlTreeStrategy.OnlyParents) {
                tree.splice(tree.length - 1, 1);
            }
            this.activatedUrlTree.next(tree);
        };
        return NtNavigationAdapter;
    }());
    NtNavigationAdapter.decorators = [
        { type: core.Injectable }
    ];
    NtNavigationAdapter.ctorParameters = function () { return [
        { type: router.ActivatedRoute },
        { type: router.Router },
        { type: undefined, decorators: [{ type: core.Inject, args: [NT_NAV_CONFIG,] }] },
        { type: Array, decorators: [{ type: core.Inject, args: [NT_NAV_MENUS,] }] }
    ]; };

    var NtNavBreadcrumbsComponent = /** @class */ (function () {
        function NtNavBreadcrumbsComponent(navAdapter) {
            this.navAdapter = navAdapter;
            this.activeUrl$ = this.navAdapter.activeUrl.asObservable();
        }
        return NtNavBreadcrumbsComponent;
    }());
    NtNavBreadcrumbsComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-nav-breadcrumbs',
                    template: "<ng-container *ngIf=\"activeUrl$ | async as activeUrl\">\n  <span class=\"nt-nav-activated-icon {{ activeUrl.icon }}\"></span>\n  <span class=\"nt-nav-activated-title\">{{ activeUrl.title }}</span>\n  <ul class=\"nt-nav-breadcrumbs-menu\">\n    <li *ngFor=\"let item of navAdapter.activatedUrlTree | async; let $index = index;\">\n      <a [routerLink]=\"['./'].concat(item.url)\">\n        {{ item.title }}\n      </a>\n    </li>\n  </ul>\n</ng-container>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-nav-breadcrumbs'
                    }
                },] }
    ];
    NtNavBreadcrumbsComponent.ctorParameters = function () { return [
        { type: NtNavigationAdapter }
    ]; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var NtNavController = /** @class */ (function () {
        function NtNavController(changeDetectorRef, navAdapter) {
            var _this = this;
            this.changeDetectorRef = changeDetectorRef;
            this.navAdapter = navAdapter;
            this.destroy = new rxjs.Subject();
            this.routeMenusUpdate = new rxjs.Subject();
            rxjs.merge(this.routeMenusUpdate, navAdapter.getRouteMenus())
                .pipe(operators.switchMap(function () { return navAdapter.getRouteMenus(); }), operators.takeUntil(this.destroy))
                .subscribe(function (menus) {
                _this._routeMenus = _this._filterRouteMenus(menus);
                _this._checkActivatedMenu();
                _this.changeDetectorRef.markForCheck();
            });
            this.navAdapter.activatedUrlTree
                .pipe(operators.takeUntil(this.destroy), operators.filter(function (tree) { return tree.length > 0; }))
                .subscribe(function () {
                _this._checkActivatedMenu();
                _this.changeDetectorRef.markForCheck();
            });
        }
        NtNavController.prototype._checkActivatedMenu = function () {
            var currentTree = this.navAdapter.activatedUrlTree.value;
            if (currentTree.length > 0) {
                var moduleName_1 = currentTree[0].url.join('/');
                var activated = this._routeMenus.find(function (menu) { return menu.path === moduleName_1; });
                if (activated) {
                    activated.folded = true;
                }
            }
        };
        NtNavController.prototype._filterRouteMenus = function (menus) {
            var _this = this;
            if (typeof this.filter !== 'function') {
                return menus;
            }
            menus = menus.filter(function (menu) {
                if (Array.isArray(menu.children) && menu.children.length > 0) {
                    return true;
                }
                else {
                    return _this.filter(menu);
                }
            });
            menus = menus.map(function (menu) {
                var copiedMenu = Object.assign({}, menu);
                if (Array.isArray(copiedMenu.children)) {
                    copiedMenu.children = copiedMenu.children.filter(function (child) { return _this.filter(child); });
                }
                return copiedMenu;
            });
            var result = [];
            menus.forEach(function (menu) {
                if (!menu.children || (Array.isArray(menu.children) && menu.children.length > 0)) {
                    result.push(Object.assign({}, menu));
                }
            });
            return result;
        };
        return NtNavController;
    }());

    var NtNavSidebarComponent = /** @class */ (function (_super) {
        __extends(NtNavSidebarComponent, _super);
        function NtNavSidebarComponent(changeDetectorRef, navAdapter) {
            var _this = _super.call(this, changeDetectorRef, navAdapter) || this;
            _this._dropdown = false;
            _this._baseUrl = navAdapter.config.baseUrl || './';
            return _this;
        }
        Object.defineProperty(NtNavSidebarComponent.prototype, "dropdown", {
            get: function () { return this._dropdown; },
            set: function (value) {
                this._dropdown = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtNavSidebarComponent.prototype, "filter", {
            get: function () { return this._filter; },
            set: function (value) {
                if (value) {
                    this._filter = value;
                    this.routeMenusUpdate.next();
                }
            },
            enumerable: false,
            configurable: true
        });
        return NtNavSidebarComponent;
    }(NtNavController));
    NtNavSidebarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-nav-sidebar',
                    template: "\n<!-- <ng-content select=\"nt-nav-sidebar-logo\"></ng-content> -->\n<div class=\"nt-nav-sidebar-brand\">\n  <img class=\"nt-nav-sidebar-logo\" [src]=\"logo\">\n  <span class=\"nt-nav-sidebar-title\" *ngIf=\"!dropdown\">{{ title }}</span>\n</div>\n\n<ul class=\"nt-nav-sidebar-root-menu\">\n  <li *ngFor=\"let parent of _routeMenus\"\n    routerLinkActive=\"active\"\n    [class.folded]=\"parent.folded\"\n    [class.has-children]=\"parent.children\">\n\n    <ng-container *ngIf=\"!dropdown else dropdownMode\">\n      <a *ngIf=\"!parent.children else hasChildrenMenus\" [routerLink]=\"parent.commands\">\n        <i [class]=\"parent.data['icon']\"></i>\n        <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n      </a>\n      <ng-template #hasChildrenMenus>\n        <a (click)=\"parent.folded = !parent.folded\">\n          <i [class]=\"parent.data['icon']\"></i>\n          <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n        </a>\n        <ul class=\"nt-nav-sidebar-nested-menu\">\n          <li *ngFor=\"let child of parent.children\" routerLinkActive=\"active\">\n            <a [routerLink]=\"child.commands\">\n              <span class=\"nt-nav-sidebar-title\">{{ child.data['title'] }}</span>\n            </a>\n          </li>\n        </ul>\n      </ng-template>\n    </ng-container>\n\n    <ng-template #dropdownMode>\n      <ng-container *ngIf=\"!parent.children else hasChildrenMenus\">\n        <a #origin=\"cdkOverlayOrigin\"\n        cdkOverlayOrigin\n        (mouseenter)=\"overlay.markOpen()\"\n        (mouseleave)=\"overlay.markClose()\"\n        [routerLink]=\"parent.commands\">\n          <i [class]=\"parent.data['icon']\"></i>\n          <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n\n          <nt-overlay\n            #overlay\n            overlayClass=\"nt-nav-dropdown-overlay\"\n            [origin]=\"origin\"\n            position=\"rightTop\"\n            [arrow]=\"true\"\n            (overlayEnter)=\"overlay.markOpen()\"\n            (overlayLeave)=\"overlay.markClose()\">\n            <div class=\"nt-nav-dropdown-pane\">\n              <div class=\"nt-nav-dropdown-title\">{{ parent.data['title'] }}</div>\n            </div>\n          </nt-overlay>\n        </a>\n      </ng-container>\n      <ng-template #hasChildrenMenus>\n        <a #origin=\"cdkOverlayOrigin\"\n          cdkOverlayOrigin\n          (mouseenter)=\"overlay.markOpen()\"\n          (mouseleave)=\"overlay.markClose()\">\n          <i [class]=\"parent.data['icon']\"></i>\n          <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n          <nt-overlay\n            #overlay\n            overlayClass=\"nt-nav-dropdown-overlay\"\n            [origin]=\"origin\"\n            position=\"rightTop\"\n            [arrow]=\"true\"\n            (overlayEnter)=\"overlay.markOpen()\"\n            (overlayLeave)=\"overlay.markClose()\">\n            <div class=\"nt-nav-dropdown-pane\">\n              <div class=\"nt-nav-dropdown-title\">{{ parent.data['title'] }}</div>\n              <ul class=\"nt-nav-dropdown-menu\">\n                <li *ngFor=\"let child of parent.children\" routerLinkActive=\"active\">\n                  <a [routerLink]=\"child.commands\">\n                    <span>{{ child.data['title'] }}</span>\n                  </a>\n                </li>\n              </ul>\n            </div>\n          </nt-overlay>\n        </a>\n      </ng-template>\n    </ng-template>\n  </li>\n</ul>\n\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-nav-sidebar',
                        '[class.dropdown-mode]': 'dropdown'
                    }
                },] }
    ];
    NtNavSidebarComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: NtNavigationAdapter }
    ]; };
    NtNavSidebarComponent.propDecorators = {
        dropdown: [{ type: core.Input }],
        filter: [{ type: core.Input }],
        title: [{ type: core.Input }],
        logo: [{ type: core.Input }]
    };

    var NtNavTopbarComponent = /** @class */ (function (_super) {
        __extends(NtNavTopbarComponent, _super);
        function NtNavTopbarComponent(changeDetectorRef, navAdapter) {
            var _this = _super.call(this, changeDetectorRef, navAdapter) || this;
            _this._baseUrl = navAdapter.config.baseUrl || './';
            return _this;
        }
        Object.defineProperty(NtNavTopbarComponent.prototype, "filter", {
            get: function () { return this._filter; },
            set: function (value) {
                if (value) {
                    this._filter = value;
                    this.routeMenusUpdate.next();
                }
            },
            enumerable: false,
            configurable: true
        });
        return NtNavTopbarComponent;
    }(NtNavController));
    NtNavTopbarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-nav-topbar',
                    template: "<ul class=\"nt-nav-topbar-menu\">\n  <li *ngFor=\"let parent of _routeMenus\" routerLinkActive=\"active\" class=\"nt-nav-topbar-menu-item\">\n    <a [routerLink]=\"parent.commands\">\n      <span [class]=\"parent.data.icon\"></span>&nbsp;&nbsp;{{ parent.data.title }}\n    </a>\n  </li>\n</ul>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'nt-nav-topbar'
                    }
                },] }
    ];
    NtNavTopbarComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef },
        { type: NtNavigationAdapter }
    ]; };
    NtNavTopbarComponent.propDecorators = {
        filter: [{ type: core.Input }]
    };

    var NtNavModule = /** @class */ (function () {
        function NtNavModule() {
        }
        NtNavModule.forRoot = function (config) {
            return {
                ngModule: NtNavModule,
                providers: [
                    { provide: NT_NAV_CONFIG, useValue: config }
                ]
            };
        };
        return NtNavModule;
    }());
    NtNavModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        router.RouterModule,
                        overlay.OverlayModule,
                        overlay$1.NtOverlayModule,
                    ],
                    exports: [
                        NtNavSidebarComponent,
                        NtNavTopbarComponent,
                        NtNavBreadcrumbsComponent,
                    ],
                    declarations: [
                        NtNavSidebarComponent,
                        NtNavTopbarComponent,
                        NtNavBreadcrumbsComponent
                    ],
                    providers: [NtNavigationAdapter]
                },] }
    ];

    exports.NT_NAV_CONFIG = NT_NAV_CONFIG;
    exports.NT_NAV_MENUS = NT_NAV_MENUS;
    exports.NtNavModule = NtNavModule;
    exports.NtNavSidebarComponent = NtNavSidebarComponent;
    exports.NtNavTopbarComponent = NtNavTopbarComponent;
    exports.NtNavigationAdapter = NtNavigationAdapter;
    exports.resolveTitle = resolveTitle;
    exports.ɵa = NtNavController;
    exports.ɵb = NtNavBreadcrumbsComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=navigation.umd.js.map
