(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/router'), require('@angular/common'), require('@ng-tangram/components/pagination')) :
  typeof define === 'function' && define.amd ? define('@ng-tangram/pro/paginator', ['exports', '@angular/core', '@angular/router', '@angular/common', '@ng-tangram/components/pagination'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.paginator = {}), global.ng.core, global.ng.router, global.ng.common, global.pagination));
}(this, (function (exports, core, router, common, pagination) { 'use strict';

  var NtPaginatorComponent = /** @class */ (function () {
      function NtPaginatorComponent(route, router) {
          this.route = route;
          this.router = router;
      }
      NtPaginatorComponent.prototype.ngOnInit = function () { };
      NtPaginatorComponent.prototype.onPageChange = function (pageNo) {
          this.router.navigate(['./'], {
              relativeTo: this.route,
              queryParams: { pageNo: pageNo },
              queryParamsHandling: 'merge'
          });
      };
      return NtPaginatorComponent;
  }());
  NtPaginatorComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'nt-paginator',
                  template: "\n    <nt-pagination [total]=\"meta.count\"\n      [pageSize]=\"meta.pageSize\"\n      [pageIndex]=\"meta.pageNo\"\n      (pageChange)=\"onPageChange($event)\">\n    </nt-pagination>\n    <span class=\"nt-paginator-metadata\">\n      \u5171 {{meta.count}} \u6761\uFF0C\u6BCF\u9875\u663E\u793A {{meta.pageSize}} \u6761\n    </span>\n  ",
                  encapsulation: core.ViewEncapsulation.None,
                  host: {
                      'class': 'nt-paginator'
                  },
                  styles: [".nt-paginator{display:contents}.nt-paginator-metadata{font-size:12}"]
              },] }
  ];
  NtPaginatorComponent.ctorParameters = function () { return [
      { type: router.ActivatedRoute },
      { type: router.Router }
  ]; };
  NtPaginatorComponent.propDecorators = {
      meta: [{ type: core.Input }]
  };

  var NtPaginatorModule = /** @class */ (function () {
      function NtPaginatorModule() {
      }
      return NtPaginatorModule;
  }());
  NtPaginatorModule.decorators = [
      { type: core.NgModule, args: [{
                  imports: [
                      common.CommonModule,
                      pagination.NtPaginationModule
                  ],
                  exports: [
                      NtPaginatorComponent,
                      pagination.NtPaginationModule
                  ],
                  declarations: [NtPaginatorComponent],
              },] }
  ];

  exports.NtPaginatorComponent = NtPaginatorComponent;
  exports.NtPaginatorModule = NtPaginatorModule;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=paginator.umd.js.map
