(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/router'), require('@ng-tangram/components/label'), require('rxjs'), require('rxjs/operators')) :
  typeof define === 'function' && define.amd ? define('@ng-tangram/pro/query-params', ['exports', '@angular/common', '@angular/core', '@angular/router', '@ng-tangram/components/label', 'rxjs', 'rxjs/operators'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.queryParams = {}), global.ng.common, global.ng.core, global.ng.router, global.nt.components.label, global.rxjs, global.rxjs.operators));
}(this, (function (exports, common, core, router, label, rxjs, operators) { 'use strict';

  var NtQueryParamComponent = /** @class */ (function () {
      function NtQueryParamComponent() {
          this.remove = new core.EventEmitter();
      }
      NtQueryParamComponent.prototype.emitRemoveEvent = function () {
          this.remove.emit(this);
      };
      return NtQueryParamComponent;
  }());
  NtQueryParamComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'nt-query-param',
                  template: "\n    <nt-label class=\"primary\">\n      {{label}}\uFF1A\n      <ng-content></ng-content>\n      <span (click)=\"emitRemoveEvent()\" class=\"fas fa-times\" class=\"clear-icon\"></span>\n    </nt-label>\n  ",
                  host: {
                      'class': 'nt-query-param'
                  }
              },] }
  ];
  NtQueryParamComponent.ctorParameters = function () { return []; };
  NtQueryParamComponent.propDecorators = {
      label: [{ type: core.Input }],
      remove: [{ type: core.Output }]
  };

  var NtQueryParamDefDirective = /** @class */ (function () {
      function NtQueryParamDefDirective(template) {
          this.template = template;
      }
      return NtQueryParamDefDirective;
  }());
  NtQueryParamDefDirective.decorators = [
      { type: core.Directive, args: [{
                  selector: '[ntQueryParamDef]',
              },] }
  ];
  NtQueryParamDefDirective.ctorParameters = function () { return [
      { type: core.TemplateRef }
  ]; };
  NtQueryParamDefDirective.propDecorators = {
      key: [{ type: core.Input, args: ['ntQueryParamDefKey',] }]
  };

  var NtQueryParamsOutletDirective = /** @class */ (function () {
      function NtQueryParamsOutletDirective(viewContainerRef) {
          this.viewContainerRef = viewContainerRef;
      }
      return NtQueryParamsOutletDirective;
  }());
  NtQueryParamsOutletDirective.decorators = [
      { type: core.Directive, args: [{
                  selector: '[ntQueryParamsOutlet]'
              },] }
  ];
  NtQueryParamsOutletDirective.ctorParameters = function () { return [
      { type: core.ViewContainerRef }
  ]; };

  var NtQueryParamsComponent = /** @class */ (function () {
      function NtQueryParamsComponent(viewContainerRef, route, router, _changeDetectorRef) {
          this.viewContainerRef = viewContainerRef;
          this.route = route;
          this.router = router;
          this._changeDetectorRef = _changeDetectorRef;
          this._destroy = new rxjs.Subject();
      }
      NtQueryParamsComponent.prototype.ngAfterViewInit = function () {
          var _this = this;
          this.route.queryParams
              .pipe(operators.delay(0), operators.takeUntil(this._destroy))
              .subscribe(function (query) {
              _this._clearViewContainer();
              _this._attachmentQueryParamItems(query);
          });
          this.queryParamDefs.changes.subscribe(function (items) {
              _this._clearViewContainer();
          });
      };
      NtQueryParamsComponent.prototype.ngOnDestroy = function () {
          this._destroy.next();
          this._destroy.complete();
      };
      NtQueryParamsComponent.prototype.clearAll = function () {
          this.router.navigate(['./'], { relativeTo: this.route });
      };
      NtQueryParamsComponent.prototype._clearViewContainer = function () {
          this._outlet.viewContainerRef.clear();
      };
      NtQueryParamsComponent.prototype._attachmentQueryParamItems = function (query) {
          var _this = this;
          var defs = this.queryParamDefs.toArray();
          var queryParamKeys = Object.keys(query);
          defs.forEach(function (def) {
              if (queryParamKeys.includes(def.key)) {
                  var context = { $implicit: query[def.key] };
                  _this._outlet.viewContainerRef.createEmbeddedView(def.template, context);
              }
          });
          this._changeDetectorRef.markForCheck();
      };
      return NtQueryParamsComponent;
  }());
  NtQueryParamsComponent.decorators = [
      { type: core.Component, args: [{
                  selector: 'nt-query-params',
                  template: "<ng-container *ntQueryParamsOutlet></ng-container>\n<div class=\"clear-all-icon\" (click)=\"clearAll()\">\u6E05\u9664</div>\n",
                  changeDetection: core.ChangeDetectionStrategy.OnPush,
                  encapsulation: core.ViewEncapsulation.None,
                  host: {
                      'class': 'nt-query-params'
                  }
              },] }
  ];
  NtQueryParamsComponent.ctorParameters = function () { return [
      { type: core.ViewContainerRef },
      { type: router.ActivatedRoute },
      { type: router.Router },
      { type: core.ChangeDetectorRef }
  ]; };
  NtQueryParamsComponent.propDecorators = {
      _outlet: [{ type: core.ViewChild, args: [NtQueryParamsOutletDirective, { static: true },] }],
      queryParamDefs: [{ type: core.ContentChildren, args: [NtQueryParamDefDirective, { descendants: true },] }]
  };

  var NtQueryParamsModule = /** @class */ (function () {
      function NtQueryParamsModule() {
      }
      return NtQueryParamsModule;
  }());
  NtQueryParamsModule.decorators = [
      { type: core.NgModule, args: [{
                  imports: [
                      common.CommonModule,
                      router.RouterModule,
                      label.NtLabelModule,
                  ],
                  declarations: [
                      NtQueryParamsComponent,
                      NtQueryParamDefDirective,
                      NtQueryParamsOutletDirective,
                      NtQueryParamComponent
                  ],
                  exports: [
                      NtQueryParamDefDirective,
                      NtQueryParamsOutletDirective,
                      NtQueryParamsComponent,
                      NtQueryParamComponent
                  ]
              },] }
  ];

  exports.NtQueryParamComponent = NtQueryParamComponent;
  exports.NtQueryParamDefDirective = NtQueryParamDefDirective;
  exports.NtQueryParamsComponent = NtQueryParamsComponent;
  exports.NtQueryParamsModule = NtQueryParamsModule;
  exports.ɵa = NtQueryParamsOutletDirective;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=query-params.umd.js.map
