(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/cdk/portal'), require('@angular/core'), require('@angular/common'), require('@ng-tangram/components/dropdown')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/reactive-action', ['exports', '@angular/cdk/coercion', '@angular/cdk/portal', '@angular/core', '@angular/common', '@ng-tangram/components/dropdown'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.reactiveAction = {}), global.ng.cdk.coercion, global.ng.cdk.portal, global.ng.core, global.ng.common, global.dropdown));
}(this, (function (exports, coercion, portal, core, common, dropdown) { 'use strict';

    var NtActionDefDirective = /** @class */ (function () {
        function NtActionDefDirective(template) {
            this.template = template;
        }
        return NtActionDefDirective;
    }());
    NtActionDefDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[ntReactiveActionDef]' },] }
    ];
    NtActionDefDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };
    var NtActionDirective = /** @class */ (function () {
        function NtActionDirective() {
        }
        return NtActionDirective;
    }());
    NtActionDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'nt-reactive-action, [nt-reactive-action]',
                    host: {
                        'class': 'nt-reactive-action'
                    }
                },] }
    ];

    var NtReactiveActionBarComponent = /** @class */ (function () {
        function NtReactiveActionBarComponent(_differs, _changeDetectorRef, _viewContainerRef) {
            this._differs = _differs;
            this._changeDetectorRef = _changeDetectorRef;
            this._viewContainerRef = _viewContainerRef;
            this._columns = 3;
            this._rows = 1;
            this.rowOverflow = false;
            this._dropdownActionItems = [];
            this._normalItems = [];
        }
        Object.defineProperty(NtReactiveActionBarComponent.prototype, "columns", {
            get: function () { return this._columns; },
            set: function (value) {
                this._columns = coercion.coerceNumberProperty(value, 1);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NtReactiveActionBarComponent.prototype, "rows", {
            get: function () { return this._rows; },
            set: function (value) {
                this._rows = coercion.coerceNumberProperty(value, 1);
            },
            enumerable: false,
            configurable: true
        });
        NtReactiveActionBarComponent.prototype.ngOnInit = function () { };
        NtReactiveActionBarComponent.prototype.ngOnChanges = function (changes) {
            var change = changes.columns || changes.rows;
            if (change && !change.firstChange) {
                this.calculateRenderItemRows();
            }
        };
        NtReactiveActionBarComponent.prototype.ngAfterViewInit = function () {
            this._dropdownPortal = new portal.TemplatePortal(this._dropdownContent, this._viewContainerRef);
        };
        NtReactiveActionBarComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.calculateRenderItemRows();
            this._itemDefs.changes.subscribe(function () {
                _this.calculateRenderItemRows();
            });
        };
        NtReactiveActionBarComponent.prototype.ngAfterContentChecked = function () {
        };
        NtReactiveActionBarComponent.prototype.renderItems = function () { };
        NtReactiveActionBarComponent.prototype.calculateRenderItemRows = function () {
            var length = this._itemDefs.length;
            var rows = Math.ceil(length / this.columns);
            this.rowOverflow = rows > this.rows;
            var itemsArray = this._itemDefs.toArray();
            ;
            if (this.rowOverflow) {
                this._normalItems = itemsArray.splice(0, this.columns * this.rows - 1);
                this._dropdownActionItems = itemsArray;
            }
            else {
                this._normalItems = itemsArray;
            }
        };
        return NtReactiveActionBarComponent;
    }());
    NtReactiveActionBarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-reactive-action-bar, [nt-reactive-action-bar]',
                    template: "<ng-container *ngFor=\"let def of _normalItems; let $index = index\">\n  <ng-container *ngTemplateOutlet=\"def?.template;\"></ng-container><br *ngIf=\"($index + 1) % columns === 0\">\n</ng-container>\n<nt-reactive-action nt-dropdown position=\"bottomRight\" trigger=\"click\" *ngIf=\"rowOverflow\">\n  <span class=\"fas fa-ellipsis-h\"></span>\n  <nt-dropdown-pane class=\"action-dropdown-pane\" arrow autosize size=\"tiny\">\n    <ng-template [cdkPortalOutlet]=\"_dropdownPortal\"></ng-template>\n  </nt-dropdown-pane>\n</nt-reactive-action>\n<ng-template #dropdownContent>\n  <ul class=\"menu vertical action-dropdown-menu\">\n    <li *ngFor=\"let def of _dropdownActionItems\">\n      <a>\n        <ng-container *ngTemplateOutlet=\"def?.template\"></ng-container>\n      </a>\n    </li>\n  </ul>\n</ng-template>\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    host: {
                        class: 'nt-reactive-action-bar'
                    },
                    styles: [""]
                },] }
    ];
    NtReactiveActionBarComponent.ctorParameters = function () { return [
        { type: core.IterableDiffers },
        { type: core.ChangeDetectorRef },
        { type: core.ViewContainerRef }
    ]; };
    NtReactiveActionBarComponent.propDecorators = {
        columns: [{ type: core.Input }],
        rows: [{ type: core.Input }],
        _dropdownContent: [{ type: core.ViewChild, args: ['dropdownContent', { static: false },] }],
        _itemDefs: [{ type: core.ContentChildren, args: [NtActionDefDirective,] }]
    };

    var NtReactiveActionModule = /** @class */ (function () {
        function NtReactiveActionModule() {
        }
        return NtReactiveActionModule;
    }());
    NtReactiveActionModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        portal.PortalModule,
                        dropdown.NtDropdownModule,
                    ],
                    exports: [
                        NtReactiveActionBarComponent,
                        NtActionDefDirective,
                        NtActionDirective
                    ],
                    declarations: [
                        NtReactiveActionBarComponent,
                        NtActionDefDirective,
                        NtActionDirective
                    ],
                },] }
    ];

    exports.NtActionDefDirective = NtActionDefDirective;
    exports.NtActionDirective = NtActionDirective;
    exports.NtReactiveActionBarComponent = NtReactiveActionBarComponent;
    exports.NtReactiveActionModule = NtReactiveActionModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=reactive-action.umd.js.map
