(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/animations'), require('@angular/core'), require('@angular/forms'), require('@ng-tangram/components/core'), require('@angular/common'), require('@ng-tangram/components/autocomplete'), require('@ng-tangram/components/input')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/search-input', ['exports', 'rxjs', 'rxjs/operators', '@angular/animations', '@angular/core', '@angular/forms', '@ng-tangram/components/core', '@angular/common', '@ng-tangram/components/autocomplete', '@ng-tangram/components/input'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.searchInput = {}), global.rxjs, global.rxjs.operators, global.ng.animations, global.ng.core, global.ng.forms, global.nt.components.core, global.ng.common, global.nt.components.autocomplete, global.nt.components.input));
}(this, (function (exports, rxjs, operators, animations, core, forms, core$1, common, autocomplete, input) { 'use strict';

    var NtSearchInputComponent = /** @class */ (function () {
        function NtSearchInputComponent() {
            var _this = this;
            this._destory = new rxjs.Subject();
            this._keywordChange = new rxjs.Subject();
            this._placeholder = '';
            this._prekeyword = '';
            this._inputing = false;
            this._keywordControl = new forms.FormControl();
            this.search = rxjs.defer(function () { return _this._keywordChange.pipe(operators.distinctUntilChanged(), operators.takeUntil(_this._destory)); });
            this.input = rxjs.defer(function () { return _this._keywordControl.valueChanges.pipe(operators.startWith(''), operators.takeUntil(_this._destory)); });
        }
        Object.defineProperty(NtSearchInputComponent.prototype, "placeholder", {
            get: function () { return this._placeholder; },
            set: function (value) {
                this._placeholder = value;
            },
            enumerable: false,
            configurable: true
        });
        NtSearchInputComponent.prototype.onEnter = function (event) {
            this._keywordChange.next(this._keywordControl.value);
            this._prekeyword = this._keywordControl.value;
        };
        NtSearchInputComponent.prototype.onBlur = function () {
            this._inputing = false;
            this._keywordControl.setValue(this._prekeyword, { emitEvent: false });
        };
        NtSearchInputComponent.prototype.clearKeyword = function (event) {
            this._keywordControl.setValue('');
            this.onEnter(event);
            event.stopPropagation();
        };
        NtSearchInputComponent.prototype.onOptionSelected = function (change) {
            this._keywordChange.next(change.option.value);
            this._keywordControl.setValue(change.option.value, { emitEvent: false });
        };
        return NtSearchInputComponent;
    }());
    NtSearchInputComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'nt-search-input',
                    template: "<nt-input-group transparent=\"true\" ntAutocompleteOrigin #origin=\"ntAutocompleteOrigin\">\n  <nt-input-addon>\n    <span class=\"fas fa-search\"></span>\n  </nt-input-addon>\n  <input type=\"text\"\n    [placeholder]=\"placeholder\"\n    [formControl]=\"_keywordControl\"\n    [ntAutocomplete]=\"auto\"\n    [ntAutocompleteConnectedTo]=\"origin\"\n    (keyup.enter)=\"onEnter($event)\"\n    (blur)=\"onBlur()\"\n    (focus)=\"_inputing = true\">\n  <nt-input-addon class=\"nt-search-input-clear\"\n    [@fade]\n    (click)=\"clearKeyword($event)\"\n    *ngIf=\"!_inputing && _prekeyword\">\n    <span class=\"fas fa-times-circle\"></span>\n  </nt-input-addon>\n</nt-input-group>\n\n<nt-autocomplete #auto=\"ntAutocomplete\" (optionSelected)=\"onOptionSelected($event)\">\n  <ng-content select=\"nt-option\"></ng-content>\n</nt-autocomplete>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    animations: [
                        animations.trigger('fade', [
                            animations.transition('void => *', core$1.fadeIn(.15)),
                            animations.transition('* => void', core$1.fadeOut(.15))
                        ])
                    ],
                    host: {
                        'class': 'nt-search-input'
                    }
                },] }
    ];
    NtSearchInputComponent.propDecorators = {
        placeholder: [{ type: core.Input }],
        search: [{ type: core.Output }],
        input: [{ type: core.Output }]
    };

    var NtSearchInputModule = /** @class */ (function () {
        function NtSearchInputModule() {
        }
        return NtSearchInputModule;
    }());
    NtSearchInputModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.ReactiveFormsModule,
                        input.NtInputModule,
                        autocomplete.NtAutocompleteModule
                    ],
                    exports: [
                        NtSearchInputComponent,
                        input.NtInputModule,
                        autocomplete.NtAutocompleteModule
                    ],
                    declarations: [
                        NtSearchInputComponent
                    ]
                },] }
    ];

    exports.NtSearchInputComponent = NtSearchInputComponent;
    exports.NtSearchInputModule = NtSearchInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=search-input.umd.js.map
