import { CommonModule } from '@angular/common';
import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';

class NtActionBarComponent {
}
NtActionBarComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-action-bar',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-action-bar'
                }
            },] }
];

class NtActionButtonComponent {
    constructor() {
        this._circle = false;
    }
    get circle() { return this._circle; }
    set circle(value) {
        this._circle = coerceBooleanProperty(value);
    }
}
NtActionButtonComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-action-button',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-action-button',
                    '[class.circle]': 'circle'
                }
            },] }
];
NtActionButtonComponent.propDecorators = {
    circle: [{ type: Input }]
};

class NtActionIconComponent {
}
NtActionIconComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-action-icon',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-action-icon'
                }
            },] }
];

class NtActionItemComponent {
}
NtActionItemComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-action-item',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-action-item'
                }
            },] }
];

const EXPORT_DECLARATIONS = [
    NtActionBarComponent,
    NtActionItemComponent,
    NtActionButtonComponent,
    NtActionIconComponent
];
class NtActionBarModule {
}
NtActionBarModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: EXPORT_DECLARATIONS,
                declarations: EXPORT_DECLARATIONS,
            },] }
];

export { NtActionBarComponent, NtActionBarModule, NtActionButtonComponent, NtActionIconComponent, NtActionItemComponent };
//# sourceMappingURL=action-bar.js.map
