import { CommonModule } from '@angular/common';
import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';

class NtPanelBodyComponent {
}
NtPanelBodyComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-panel-body, [nt-panel-body]',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-panel-body'
                }
            },] }
];

class NtPanelFooterComponent {
    get small() { return this._small; }
    set small(value) {
        this._small = coerceBooleanProperty(value);
    }
    get large() { return this._large; }
    set large(value) {
        this._large = coerceBooleanProperty(value);
    }
}
NtPanelFooterComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-panel-footer, [nt-panel-footer]',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-panel-footer',
                    '[class.small]': 'small',
                    '[class.large]': 'large'
                }
            },] }
];
NtPanelFooterComponent.propDecorators = {
    small: [{ type: Input }],
    large: [{ type: Input }]
};

class NtPanelHeaderComponent {
    get small() { return this._small; }
    set small(value) {
        this._small = coerceBooleanProperty(value);
    }
    get large() { return this._large; }
    set large(value) {
        this._large = coerceBooleanProperty(value);
    }
}
NtPanelHeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-panel-header, [nt-panel-header]',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-panel-header',
                    '[class.small]': 'small',
                    '[class.large]': 'large'
                }
            },] }
];
NtPanelHeaderComponent.propDecorators = {
    small: [{ type: Input }],
    large: [{ type: Input }]
};

class NtPanelWrapperComponent {
}
NtPanelWrapperComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-panel-wrapper, [nt-panel-wrapper]',
                template: `<ng-content select="nt-panel"></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-panel-wrapper'
                }
            },] }
];

class NtPanelComponent {
    constructor() {
        this._shrink = false;
        this._flexable = true;
    }
    get shrink() { return this._shrink; }
    set shrink(value) {
        this._shrink = coerceBooleanProperty(value);
    }
    get flexable() { return this._flexable; }
    set flexable(value) {
        this._flexable = coerceBooleanProperty(value);
    }
}
NtPanelComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-panel, [nt-panel]',
                template: `
    <ng-content select="nt-panel-header"></ng-content>
    <ng-content select="nt-panel-body"></ng-content>
    <ng-content select="nt-panel-footer"></ng-content>
  `,
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-panel',
                    '[class.nt-panel-shrink]': 'shrink',
                    '[class.nt-panel-flexable]': 'flexable',
                }
            },] }
];
NtPanelComponent.propDecorators = {
    shrink: [{ type: Input }],
    flexable: [{ type: Input }]
};

const EXPORT_DECLARATIONS = [
    NtPanelBodyComponent,
    NtPanelFooterComponent,
    NtPanelHeaderComponent,
    NtPanelWrapperComponent,
    NtPanelComponent
];
class NtPanelModule {
}
NtPanelModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: EXPORT_DECLARATIONS,
                declarations: EXPORT_DECLARATIONS,
            },] }
];

export { NtPanelBodyComponent, NtPanelComponent, NtPanelFooterComponent, NtPanelHeaderComponent, NtPanelModule, NtPanelWrapperComponent };
//# sourceMappingURL=containers.js.map
