import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { CommonModule } from '@angular/common';
import { NtPaginationModule } from '@ng-tangram/components/pagination';

class NtPaginatorComponent {
    constructor(route, router) {
        this.route = route;
        this.router = router;
    }
    ngOnInit() { }
    onPageChange(pageNo) {
        this.router.navigate(['./'], {
            relativeTo: this.route,
            queryParams: { pageNo },
            queryParamsHandling: 'merge'
        });
    }
}
NtPaginatorComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-paginator',
                template: `
    <nt-pagination [total]="meta.count"
      [pageSize]="meta.pageSize"
      [pageIndex]="meta.pageNo"
      (pageChange)="onPageChange($event)">
    </nt-pagination>
    <span class="nt-paginator-metadata">
      共 {{meta.count}} 条，每页显示 {{meta.pageSize}} 条
    </span>
  `,
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-paginator'
                },
                styles: [".nt-paginator{display:contents}.nt-paginator-metadata{font-size:12}"]
            },] }
];
NtPaginatorComponent.ctorParameters = () => [
    { type: ActivatedRoute },
    { type: Router }
];
NtPaginatorComponent.propDecorators = {
    meta: [{ type: Input }]
};

class NtPaginatorModule {
}
NtPaginatorModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    NtPaginationModule
                ],
                exports: [
                    NtPaginatorComponent,
                    NtPaginationModule
                ],
                declarations: [NtPaginatorComponent],
            },] }
];

export { NtPaginatorComponent, NtPaginatorModule };
//# sourceMappingURL=paginator.js.map
