import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Component, ViewEncapsulation, Input, NgModule } from '@angular/core';

class NtSkeletonComponent {
    constructor() {
        this._circle = false;
        this._inline = false;
    }
    get circle() { return this._circle; }
    set circle(value) {
        if (value !== this.circle) {
            this._circle = coerceBooleanProperty(value);
        }
    }
    get inline() { return this._inline; }
    set inline(value) {
        if (value !== this.inline) {
            this._inline = coerceBooleanProperty(value);
        }
    }
}
NtSkeletonComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-skeleton, [nt-skeleton]',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    'class': 'nt-skeleton',
                    '[class.circle]': 'circle',
                    '[class.inline]': 'inline',
                }
            },] }
];
NtSkeletonComponent.propDecorators = {
    circle: [{ type: Input }],
    inline: [{ type: Input }]
};

class NtSkeletonModule {
}
NtSkeletonModule.decorators = [
    { type: NgModule, args: [{
                exports: [NtSkeletonComponent],
                declarations: [NtSkeletonComponent]
            },] }
];

export { NtSkeletonComponent, NtSkeletonModule };
//# sourceMappingURL=skeleton.js.map
